<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetParcelShopInAreaRequestType StructType
 * @subpackage Structs
 */
class GetParcelShopInAreaRequestType extends AbstractStructBase
{
    /**
     * The Credentials
     * @var \StructType\GLSUserCredentials
     */
    public $Credentials;
    /**
     * The From
     * @var \StructType\GLSCoordinates
     */
    public $From;
    /**
     * The To
     * @var \StructType\GLSCoordinates
     */
    public $To;
    /**
     * Constructor method for GetParcelShopInAreaRequestType
     * @uses GetParcelShopInAreaRequestType::setCredentials()
     * @uses GetParcelShopInAreaRequestType::setFrom()
     * @uses GetParcelShopInAreaRequestType::setTo()
     * @param \StructType\GLSUserCredentials $credentials
     * @param \StructType\GLSCoordinates $from
     * @param \StructType\GLSCoordinates $to
     */
    public function __construct(\StructType\GLSUserCredentials $credentials = null, \StructType\GLSCoordinates $from = null, \StructType\GLSCoordinates $to = null)
    {
        $this
            ->setCredentials($credentials)
            ->setFrom($from)
            ->setTo($to);
    }
    /**
     * Get Credentials value
     * @return \StructType\GLSUserCredentials|null
     */
    public function getCredentials()
    {
        return $this->Credentials;
    }
    /**
     * Set Credentials value
     * @param \StructType\GLSUserCredentials $credentials
     * @return \StructType\GetParcelShopInAreaRequestType
     */
    public function setCredentials(\StructType\GLSUserCredentials $credentials = null)
    {
        $this->Credentials = $credentials;
        return $this;
    }
    /**
     * Get From value
     * @return \StructType\GLSCoordinates|null
     */
    public function getFrom()
    {
        return $this->From;
    }
    /**
     * Set From value
     * @param \StructType\GLSCoordinates $from
     * @return \StructType\GetParcelShopInAreaRequestType
     */
    public function setFrom(\StructType\GLSCoordinates $from = null)
    {
        $this->From = $from;
        return $this;
    }
    /**
     * Get To value
     * @return \StructType\GLSCoordinates|null
     */
    public function getTo()
    {
        return $this->To;
    }
    /**
     * Set To value
     * @param \StructType\GLSCoordinates $to
     * @return \StructType\GetParcelShopInAreaRequestType
     */
    public function setTo(\StructType\GLSCoordinates $to = null)
    {
        $this->To = $to;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetParcelShopInAreaRequestType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
