<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetParcelShopRequestType StructType
 * @subpackage Structs
 */
class GetParcelShopRequestType extends AbstractStructBase
{
    /**
     * The Address
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var \StructType\GLSAddress
     */
    public $Address;
    /**
     * The Credentials
     * @var \StructType\GLSUserCredentials
     */
    public $Credentials;
    /**
     * Constructor method for GetParcelShopRequestType
     * @uses GetParcelShopRequestType::setAddress()
     * @uses GetParcelShopRequestType::setCredentials()
     * @param \StructType\GLSAddress $address
     * @param \StructType\GLSUserCredentials $credentials
     */
    public function __construct(\StructType\GLSAddress $address = null, \StructType\GLSUserCredentials $credentials = null)
    {
        $this
            ->setAddress($address)
            ->setCredentials($credentials);
    }
    /**
     * Get Address value
     * @return \StructType\GLSAddress
     */
    public function getAddress()
    {
        return $this->Address;
    }
    /**
     * Set Address value
     * @param \StructType\GLSAddress $address
     * @return \StructType\GetParcelShopRequestType
     */
    public function setAddress(\StructType\GLSAddress $address = null)
    {
        $this->Address = $address;
        return $this;
    }
    /**
     * Get Credentials value
     * @return \StructType\GLSUserCredentials|null
     */
    public function getCredentials()
    {
        return $this->Credentials;
    }
    /**
     * Set Credentials value
     * @param \StructType\GLSUserCredentials $credentials
     * @return \StructType\GetParcelShopRequestType
     */
    public function setCredentials(\StructType\GLSUserCredentials $credentials = null)
    {
        $this->Credentials = $credentials;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetParcelShopRequestType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
